import pytest,allure,xlrd,requests,os
from common.utils.getExcelData import  get_excelData
from service.login import BMY
from common.tools import request_main
from common.db import RedisString, MYSQL
from config import BmyomsConfig,BaseConfig
from service.login import BMY

@allure.epic("斑马企业云oms")
@allure.feature("企业管理")
class TestProductManagement():
    workBook = xlrd.open_workbook(f'{BmyomsConfig.root_path}/test_case_data/bmy/bmy_oms_ApplicationManagement_20210806.xlsx')
    # @allure.story("企业管理")
    # @allure.title("{inData[testPoint]}")
    # @allure.testcase("http://yapi.hikcreate.com/project/364/interface/api/90509")
    # @allure.description("企业订单")
    # @pytest.mark.parametrize("inData", get_excelData(workBook, '企业管理', 'product'))
    # def test_product(self, inData):
    #     url = f"{BmyomsConfig().test_host}{inData['url']}"
    #     headers = inData['headers']
    #     method = inData['method']
    #     data = inData['reqData']
    #     expectData = inData['expectData']
    #     res = request_main(url, headers, method, data)
    #     allure.attach(f"{res}", "响应结果", allure.attachment_type.TEXT)
    #     assert res['code'] == expectData['code']

    @allure.story("企业管理")
    @allure.title("{inData[testPoint]}")
    @allure.testcase("http://yapi.hikcreate.com/project/364/interface/api/90509")
    @allure.description("企业订单")
    @pytest.mark.parametrize("inData", get_excelData(workBook, '企业管理', 'cpcn'))
    def test_cpcn(self, inData):
        url = f"{BmyomsConfig().test_host}{inData['url']}"
        headers = inData['headers']
        method = inData['method']
        expectData = inData['expectData']
        mysql = MYSQL(*BaseConfig.test_mysql)
        if mysql.ExecuQuery("select id from hik_trade.cpcn_split_rule csr where order_source =0028 and merchant_num ='2COXcXC2109131127002' and is_delete =0 "):
            id=mysql.ExecuQuery("select id from hik_trade.cpcn_split_rule csr where order_source =0028 and merchant_num ='2COXcXC2109131127002' and is_delete =0 ")
            id=id[0]['id']
            inData['reqData']['id']=id
            data = inData['reqData']
        elif inData['testPoint']=='分账删除':
            id = mysql.ExecuQuery("select id from hik_trade.cpcn_split_rule csr where order_source =0028 and merchant_num ='2COXcXC2109131127002' and is_delete =0 ")
            id = id[0]['id']
            inData['reqData']['id'] = id
            data = inData['reqData']
        else:
            data = inData['reqData']
        print(data)
        res = request_main(url, headers, method, data)
        allure.attach(f"{res}", "响应结果", allure.attachment_type.TEXT)
        assert res['code'] == expectData['code']

if __name__ == '__main__':

    for one in os.listdir('../../report/tmp'):  # 列出对应文件夹的数据
        if 'json' in one:
            os.remove(f'../../report/tmp/{one}')
    pytest.main(['test_ProductManagement.py', '-s', '--alluredir', '../../report/tmp'])
    # # 启动默认浏览器打开报告
    os.system('allure serve ../../report/tmp')